SoTextureScalePolicy(3)

NAME
SoTextureScalePolicy - The SoTextureScalePolicy class is a node for controlling the texture scale policy.

SYNOPSIS

#include <Inventor/nodes/SoTextureScalePolicy.h>

Inherits SoNode.

  Public Types
enum Policy { USE_TEXTURE_QUALITY, SCALE_DOWN, SCALE_UP, FRACTURE }

  Public Member Functions
virtual SoType getTypeId (void) const
SoTextureScalePolicy (void)
virtual void GLRender (SoGLRenderAction *action)

  Static Public Member Functions
static SoType getClassTypeId (void)
static void initClass (void)
Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.

  Public Attributes
SoSFEnum policy
SoSFFloat quality

  Protected Member Functions
virtual const SoFieldData * getFieldData (void) const
virtual ~SoTextureScalePolicy ()

  Static Protected Member Functions
static const SoFieldData ** getFieldDataPtr (void)

  Additional Inherited Members

Detailed Description

The SoTextureScalePolicy class is a node for controlling the texture scale policy. If a texture map is of size != 2^n, it must be scaled before OpenGL can handle it. This node enables you to control how/if textures are scaled before they are sent to OpenGL.

Also, if a texture map is bigger than the maximum OpenGL texture size (implementation and context dependent), it will be scaled down to the maximum size. You can avoid this by setting the texture policy to SoTextureScalePolicy::FRACTURE, in which case the texture will be split into several small subtextures before the geometry using the texture is rendered.

Setting SoTextureScalePolicy::policy to SoTextureScalePolicy::FRACTURE will also cause the internal texture handling unit in Coin to automatically downsample the individual subtextures to not use more graphics card memory than necessary to cover the current screen size of the texture.

These two aspects of SoTextureScalePolicy::FRACTURE rendering together, subtexture fracturing and automatic downsampling, makes it possible to have textures with almost unlimited size. The only real limit is the amount of memory on the system, since the entire texture must fit into CPU memory.

The SoTextureScalePolicy::FRACTURE policy is also very handy for using the Coin libraries built-in handling of non-power-of-2 textures. This will then be done completely transparent to the application programmer, for maximum convenience. Below is a very simple example which demonstrates how to use it. The texture has dimensions 3x3, but no scaling (and thereby interpolation) will have to be done when SoTextureScalePolicy::FRACTURE is specified:

#Inventor V2.1 ascii
Separator {
   TextureScalePolicy { policy FRACTURE }
   Complexity { textureQuality 0.01 }  # don't generate smoothed mipmaps
   Texture2 {
      image 3 3 4  # dimensions 3x3, RGBA (4-component) image
      0xff0000ff 0x00ff00ff 0x0000ffff  # red, green, blue
      0xffff00ff 0xff00ffff 0x00ffffff  # yellow, magenta, cyan
      0x222222ff 0x777777ff 0xccccccff  # dark, medium and light gray
   }
   Cube { }
}

Be aware that the triangle throughput is much slower when using the FRACTURE texture mode, since all triangles need to be clipped (using the CPU) against subtextures. It's therefore usually not a good idea to use the FRACTURE mode on large triangle meshes.

Be aware that this class is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.
 FILE FORMAT/DEFAULTS:

TextureScalePolicy {
    policy USE_TEXTURE_QUALITY
    quality 0.5
}

Since
    Coin 2.0

Member Enumeration Documentation

  enum SoTextureScalePolicy::Policy
Enumerates the available policy settings.

Enumerator

USE_TEXTURE_QUALITY
    Uses the texture quality to decide whether to scale up or down.

SCALE_DOWN
    Always scales down.

SCALE_UP
    Always scales up.

FRACTURE
    Splits the texture into several subtextures, and clips the geometry into each subtexture. Also automatically downsamples the subtextures to not use more graphics card memory than necessary versus the current screen size of the texture.

These two features makes it possible to have textures with almost unlimited size. The only real limit is the amount of memory on the system, since the entire texture must fit into CPU memory.

Be aware that the rendering is quite slow with this mode if the texture(s) will be mapped onto lots of polygon primitives.

Constructor & Destructor Documentation

  SoTextureScalePolicy::SoTextureScalePolicy (void)
Constructor.

  SoTextureScalePolicy::~SoTextureScalePolicy () [protected], [virtual]
Destructor.

Member Function Documentation

  SoType SoTextureScalePolicy::getClassTypeId (void) [static]
This static method returns the SoType object associated with objects of this class.

  SoType SoTextureScalePolicy::getTypeId (void) const [virtual]
Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and 'downward' casting.

Implements SoBase.

  const SoFieldData ** SoTextureScalePolicy::getFieldDataPtr (void) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
 Returns the SoFieldData class which holds information about fields in this node.

  const SoFieldData * SoTextureScalePolicy::getFieldData (void) const [protected], [virtual]
Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns NULL.

Reimplemented from SoFieldContainer.

  void SoTextureScalePolicy::GLRender (SoGLRenderAction * action) [virtual]
Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or want to throw geometry primitives at OpenGL override this method.

Reimplemented from SoNode.

Member Data Documentation

  SoSFEnum SoTextureScalePolicy::policy
The policy setting. Default value is USE_TEXTURE_QUALITY.

USE_TEXTURE_QUALITY means that SoComplexity::textureQuality will be used to decide if the texture should be scaled up or down. SoComplexity::textureQuality >= 0.7 means scale up, while < 0.7 means scale down. Textures smaller than 256 pixels are never scaled down since you lose too much information.

  SoSFFloat SoTextureScalePolicy::quality
The texture scale/resize quality. Default value is 0.5.

This field can be used to force Coin to use a lower quality (but much faster) image resize function. Currently, if you set this field to a value < 0.5, a low quality resize function will be used, otherwise a high quality (but slow) function will be used.

Author

Generated automatically by Doxygen for Coin from the source code.